package ZipTie::Adapters::Brocade::vRouter::Utils;

use strict;
use warnings;
use 5.010_000;

use Exporter qw(import);
our @EXPORT_OK = qw(clean_responses);

# Brocade has control commands in its cli output that we capture.
# This sub cleans the repsonses of them for easier parsing.
sub clean_responses {
	my ( $responses ) = @_;
	my %clean_responses;
	for my $key ( keys %{ $responses } ) {
		my $value = $responses->{$key};
	
		# !! Notice !! '' is one character, in the below sequences.
	
		# 1. Each line will end with a control character sequence '[m'
		# 2. The start of the responses, after the command itself, will
		# also have a sequence of control characters '[?1h='.
		# 3. Before the prompt is output after the response another
		# sequence usually occurs '[K[?1l>'
		if( $value =~ s/\[m//g ) {
			# More risk with these regex, only do if we see the
			# newline sequence
			$value =~ s/^\[\?1h=//mg; 
			$value =~ s/^\[K\[?1l>//mg;
		}
		$clean_responses{$key} = $value;
	}
	return \%clean_responses;
}

1;
